package org.ow2.jonas.admin.auditconsole.model {
import mx.collections.ArrayCollection;

import org.ow2.jonas.admin.auditconsole.vo.GenericAuditReportVO;

/**
 * Sliding window for the main chart of the app.
 */
[Bindable]
public class ChartModel {

    public var reportsEJB:ArrayCollection = null;
    public var reportsJNDI:ArrayCollection = null;
    public var reportsWEB:ArrayCollection = null;
    public var reportsDates:ArrayCollection = null;

    public function ChartModel() {
        reportsEJB = new ArrayCollection();
        reportsJNDI = new ArrayCollection();
        reportsWEB = new ArrayCollection();
        reportsDates = new ArrayCollection();
    }

    public function addReport(report:GenericAuditReportVO):void {
        if (AuditConsoleModelLocator.getInstance().filterReports(report)) {
            if (reportsEJB.length > AuditConsoleModelLocator.getInstance().config.auditSamples) {
                reportsEJB.removeItemAt(0);
                reportsWEB.removeItemAt(0);
                reportsJNDI.removeItemAt(0);
                reportsDates.removeItemAt(0);
            }
            if (report.isEJBInvocation()) {
               reportsEJB.addItem(report);
               reportsWEB.addItem(null);
               reportsJNDI.addItem(null);
            }
            if (report.isWEBInvocation()) {
               reportsEJB.addItem(null);
               reportsWEB.addItem(report);
               reportsJNDI.addItem(null);
            }
            if (report.isJNDIInvocation()) {
               reportsEJB.addItem(null);
               reportsWEB.addItem(null);
               reportsJNDI.addItem(report);
            }
            reportsDates.addItem(report.chartDate);
        }
    }

    public function removeAllReports():void {
        reportsEJB.removeAll();
        reportsJNDI.removeAll();
        reportsWEB.removeAll();
        reportsDates.removeAll();
    }

    public function reinitializeReportCollection():void {
        removeAllReports();
        for (var i:int = AuditConsoleModelLocator.getInstance().config.auditSamples; i > -1 ; i--) {
            if (i <= (AuditConsoleModelLocator.getInstance().reports.length - 1)) {
                addReport(AuditConsoleModelLocator.getInstance().reports.getItemAt(i) as GenericAuditReportVO);
            }
        }
    }
}
}