/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 2009 Bull S.A.S.
 * Contact: jonas-team@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: BasicAuditReportVO.as 19356 2010-03-04 21:02:36Z mancelin $
 * --------------------------------------------------------------------------
 */

package org.ow2.jonas.admin.auditconsole.vo {
import com.adobe.cairngorm.vo.IValueObject;

import mx.formatters.DateFormatter;

/**
 * Object that represent a basic audit report.
 */
[RemoteClass(alias="org.ow2.util.auditreport.impl.BasicAuditReport")]
[Bindable]
public class BasicAuditReportVO implements IValueObject {

    public var requestTimeStamp : Number = 0;
    /**
     * Constructor.
     */
    public function BasicAuditReportVO() {}

    public function toString():String {
        var formater:DateFormatter = new DateFormatter();
            formater.formatString = "EEEE, MMM. D, YYYY at H:NN:SS";
            var date:Date = new Date(requestTimeStamp);
            return "Timestamp : "
                    + requestTimeStamp
                    + " - "
                    + formater.format(date);
    }

    public function toHTMLString():String {
        var formater:DateFormatter = new DateFormatter();
            formater.formatString = "EEEE, MMM. D, YYYY at H:NN:SS";
            var date:Date = new Date(requestTimeStamp);
            return "<font color=\"#FF0000\"><b>Timestamp</b></font> : "
                    + requestTimeStamp
                    + " - "
                    + formater.format(date)
                    + "<br/>";
    }

    public function get chartDate():String {
        var formater:DateFormatter = new DateFormatter();
        formater.formatString = "H:NN:SS";
        var date:Date = new Date(requestTimeStamp);
        return formater.format(date) + "," + date.getMilliseconds();
    }

    public function get dateAsString():String {
        var formater:DateFormatter = new DateFormatter();
        formater.formatString = "YYYY/MM/DD at H:NN:SS";
        var date:Date = new Date(requestTimeStamp);
        return formater.format(date) + "," + date.getMilliseconds();
    }
}
}